- [HTTP request](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.FetchRemoteAgentsInformationResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#body.aspect_1)
- [RemoteAgentInfoResponse](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RemoteAgentInfoResponse)
  - [JSON representation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RemoteAgentInfoResponse.SCHEMA_REPRESENTATION)
- [AgentCommunicationStatus](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#AgentCommunicationStatus)
- [HighAvailabilityStatus](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#HighAvailabilityStatus)
- [RedeployInformation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RedeployInformation)
  - [JSON representation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RedeployInformation.SCHEMA_REPRESENTATION)
- [AgentConnectorsMigrationStatus](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#AgentConnectorsMigrationStatus)

**Full name**: projects.locations.instances.remoteAgents.fetchRemoteAgentsInformation

Retrieves detailed information for a list of RemoteAgents. Use this method to get real-time communication status, hardware information, and advanced diagnostic metadata for multiple agents in a single request.

### HTTP request

`POST https://{endpoint}/v1alpha/{parent}/remoteAgents:fetchRemoteAgentsInformation`

Where `{endpoint}` is one of the [supported service endpoints](https://docs.cloud.google.com/chronicle/docs/reference/rest#rest_endpoints).

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. Format: projects/{project}/locations/{location}/instances/{instance} |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "remoteAgentIdentifiers": [ string ] } ``` |

| Fields ||
|---|---|
| `remoteAgentIdentifiers[]` | `string` Required. List of remote agent identifiers. |

### Response body

Response message for the FetchAgentsInformation method.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "remoteAgentInfoResponses": [ { object (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RemoteAgentInfoResponse`) } ] } ``` |

| Fields ||
|---|---|
| `remoteAgentInfoResponses[]` | ``object (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RemoteAgentInfoResponse`)`` Output only. List of remote agents information. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/chronicle`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `parent` resource:

- `chronicle.remoteAgents.get`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).

## RemoteAgentInfoResponse

Information about a specific remote agent.

| JSON representation |
|---|
| ``` { "identifier": string, "displayName": string, "lastCommunicationTime": string, "lastActionExecutionTime": string, "version": string, "requiredPlatformVersion": string, "ipAddress": string, "hostName": string, "communicationStatus": enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#AgentCommunicationStatus`), "highAvailabilityStatus": enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#HighAvailabilityStatus`), "usages": [ string ], "deploymentType": enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/InstallationType`), "loggingLevel": enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents#RemoteAgentLogLevel`), "redeployInfo": { object (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RedeployInformation`) }, "latestRemoteAgentVersion": string, "connectorsMigrationStatus": enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#AgentConnectorsMigrationStatus`), "availableForLoggingLevel": boolean, "upgradeAvailable": boolean, "majorUpgrade": boolean, "latestVersion": boolean, "supportCloudLogging": boolean, "supportConnectorsHighAvailability": boolean } ``` |

| Fields ||
|---|---|
| `identifier` | `string` Output only. Unique GUID Identifier of the remote agent |
| `displayName` | `string` Output only. The display name of the remote agent. |
| `lastCommunicationTime` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Last communication time with the remote agent in unix time. |
| `lastActionExecutionTime` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Last action execution time in the remote agent in unix time. |
| `version` | `string` Output only. Represents the remote agent's current version. |
| `requiredPlatformVersion` | `string` Output only. Required platform version to run any integration on the remote agent. |
| `ipAddress` | `string` Output only. Represents the remote agent's IP address. |
| `hostName` | `string` Output only. Represents the remote agent's host name. |
| `communicationStatus` | ``enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#AgentCommunicationStatus`)`` Output only. Indicates the remote agent's current communication status in real time. |
| `highAvailabilityStatus` | ``enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#HighAvailabilityStatus`)`` Output only. Indicates the secondary remote agent's communication status in real time. The secondary remote agent acts as a backup mechanism in case the primary remote agent becomes unavailable - for example due to high load. Therefore, it is named as HighAvailabilityStatus. |
| `usages[]` | `string` Output only. List of all integrations, connectors and jobs installed on the remote agent for a specific integration identifier. |
| `deploymentType` | ``enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/InstallationType`)`` Output only. Remote agent installation type |
| `loggingLevel` | ``enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents#RemoteAgentLogLevel`)`` Output only. Logging level on the remote agent. |
| `redeployInfo` | ``object (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#RedeployInformation`)`` Output only. Remote agent redeployment information. |
| `latestRemoteAgentVersion` | `string` Output only. The remote agent latest version available for upgrade (Available on publisher). |
| `connectorsMigrationStatus` | ``enum (`https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances.remoteAgents/fetchRemoteAgentsInformation#AgentConnectorsMigrationStatus`)`` Output only. Connectors migration status. |
| `availableForLoggingLevel` | `boolean` Output only. Indicates if the remote agent logging level can be changed. |
| `upgradeAvailable` | `boolean` Output only. Indicates if the remote agent has an available new version to which it can be upgraded. |
| `majorUpgrade` | `boolean` Output only. Indicates if the remote agent's version is a major version or not. Major upgrade - upgrade of the renote agent that needs client intervention. E.g. deploying new docker image. |
| `latestVersion` | `boolean` Output only. Indicates if the remote agent version is the latest. |
| `supportCloudLogging` | `boolean` Output only. Indicates if the remote agent is compatible with cloud logging. |
| `supportConnectorsHighAvailability` | `boolean` Output only. Indicates if the remote agent supports high availability for connectors. |

## AgentCommunicationStatus

Possible values for the remote agent's current communication status.

| Enums ||
|---|---|
| `AGENT_COMMUNICATION_STATUS_UNSPECIFIED` | Agent status is unspecified. |
| `LIVE` | An agent status of 'live' means it has an active connection with the system. |
| `ERROR` | An agent status of 'error' means it does not have an active connection with the system. |
| `DISABLED` | An agent status of 'disabled' means it was disabled by the user and can be re-enabled in the future. |
| `WAITING_FOR_AGENT` | An agent status of 'waiting for agent' means either the system is waiting for a connection response from the agent or the agent is undergoing a process such as an upgrade. |
| `DELETED` | Agent current status is deleted. |

## HighAvailabilityStatus

Indicates the secondary remote agent's communication status in real time, as reported by the system.

| Enums ||
|---|---|
| `HIGH_AVAILABILITY_STATUS_UNSPECIFIED` | Remote agent status is unspecified. |
| `LIVE` | The secondary remote agent is fully operational. |
| `ERROR` | There is a mismatch in versions between the remote agent and the platform, or the status cannot be calculated. |
| `DISABLED` | Either the Primary or the secondary remote agent is disabled. |
| `PENDING_SECONDARY_AGENT` | A secondary remote agent status of 'Pending Secondary Agent' means that the secondary remote agent is in a pending state either because the systme is waiting for a connection response from the remote agent or the remote agent is undergoing a process and waiting for it to finish. |
| `NOT_CONFIGURED` | This indicates that a secondary remote agent does not exist. |

## RedeployInformation

Remote agent redeployment information.

| JSON representation |
|---|
| ``` { "sourceDeployedAgent": string, "redeployed": boolean } ``` |

| Fields ||
|---|---|
| `sourceDeployedAgent` | `string` Output only. If the remote agent was redeployed from a different remote agent, then this field indicates the source remote agent's identifier. |
| `redeployed` | `boolean` Output only. Indicates if the remote agent was redeployed from another remote agent. |

## AgentConnectorsMigrationStatus

Represents the migration status of remote agent connectors.

| Enums ||
|---|---|
| `AGENT_CONNECTORS_MIGRATION_STATUS_UNSPECIFIED` | AgentConnectorsMigrationStatus is unspecified. |
| `PENDING` | Migration is pending. |
| `IN_PROGRESS` | Migration is in progress for at least one connector. |
| `COMPLETED` | Migration is complete or no migration is required. |
| `FAILED` | Migration has failed for at least one connector. |